/* WGPermissionOptionController.m created by epeyton on Wed 18-Aug-1999 */

#import "WGPermissionOptionController.h"

@implementation WGPermissionOptionController

- (void)loadFromDictionary:(NSDictionary *)aDict
{
    if ([aDict objectForKey:@"AllowedFilePrefixes"]) {
        [allowedFilePrefixesTextField setStringValue:[aDict objectForKey:@"AllowedFilePrefixes"]];
    }
    if ([aDict objectForKey:@"DisAllowedFilePrefixes"]) {
        [disAllowedFilePrefixesTextField setStringValue:[aDict objectForKey:@"DisAllowedFilePrefixes"]];
    }
    if ([aDict objectForKey:@"AllowedFileSuffixes"]) {
        [allowedFileSuffixesTextField setStringValue:[aDict objectForKey:@"AllowedFileSuffixes"]];
    }
    if ([aDict objectForKey:@"DisAllowedFileSuffixes"]) {
        [disAllowedFileSuffixesTextField setStringValue:[aDict objectForKey:@"DisAllowedFileSuffixes"]];
    }
    if ([aDict objectForKey:@"AllowedDomains"]) {
        [allowedDomainsTextField setStringValue:[aDict objectForKey:@"AllowedDomains"]];
    }
    if ([aDict objectForKey:@"DisAllowedDomains"]) {
        [disAllowedDomainsTextField setStringValue:[aDict objectForKey:@"DisAllowedDomains"]];
    }
    if ([aDict objectForKey:@"AllowedMIMETypes"]) {
        [allowedMIMETypesTextField setStringValue:[aDict objectForKey:@"AllowedMIMETypes"]];
    }
    if ([aDict objectForKey:@"DisAllowedMIMETypes"]) {
        [disAllowedMIMETypesTextField setStringValue:[aDict objectForKey:@"DisAllowedMIMETypes"]];
    }
    if ([aDict objectForKey:@"AllowedSites"]) {
        [allowedSitesTextField setStringValue:[aDict objectForKey:@"AllowedSites"]];
    }
    if ([aDict objectForKey:@"DisAllowedSites"]) {
        [disAllowedSitesTextField setStringValue:[aDict objectForKey:@"DisAllowedSites"]];
    }
    if ([aDict objectForKey:@"AllowedFilePatterns"]) {
        [allowedFilePatternsTextField setStringValue:[aDict objectForKey:@"AllowedFilePatterns"]];
    }
    if ([aDict objectForKey:@"DisAllowedFilePatterns"]) {
        [disAllowedFilePatternsTextField setStringValue:[aDict objectForKey:@"DisAllowedFilePatterns"]];
    }
    if ([aDict objectForKey:@"AllowedURLPatterns"]) {
        [allowedURLPatternsTextField setStringValue:[aDict objectForKey:@"AllowedURLPatterns"]];
    }
    if ([aDict objectForKey:@"DisAllowedURLPatterns"]) {
        [disAllowedURLPatternsTextField setStringValue:[aDict objectForKey:@"DisAllowedURLPatterns"]];
    }

    return;
}

- (NSDictionary *)saveDict
{
    NSMutableDictionary *retDict = [NSMutableDictionary dictionary];

    [retDict setObject:[allowedFilePrefixesTextField stringValue] forKey:@"AllowedFilePrefixes"];
    [retDict setObject:[disAllowedFilePrefixesTextField stringValue] forKey:@"DisAllowedFilePrefixes"];
    [retDict setObject:[allowedFileSuffixesTextField stringValue] forKey:@"AllowedFileSuffixes"];
    [retDict setObject:[disAllowedFileSuffixesTextField stringValue] forKey:@"DisAllowedFileSuffixes"];
    [retDict setObject:[allowedDomainsTextField stringValue] forKey:@"AllowedDomains"];
    [retDict setObject:[disAllowedDomainsTextField stringValue] forKey:@"DisAllowedDomains"];
    [retDict setObject:[allowedMIMETypesTextField stringValue] forKey:@"AllowedMIMETypes"];
    [retDict setObject:[disAllowedMIMETypesTextField stringValue] forKey:@"DisAllowedMIMETypes"];
    [retDict setObject:[allowedSitesTextField stringValue] forKey:@"AllowedSites"];
    [retDict setObject:[disAllowedSitesTextField stringValue] forKey:@"DisAllowedSites"];
    [retDict setObject:[allowedFilePatternsTextField stringValue] forKey:@"AllowedFilePatterns"];
    [retDict setObject:[disAllowedFilePatternsTextField stringValue] forKey:@"DisAllowedFilePatterns"];
    [retDict setObject:[allowedURLPatternsTextField stringValue] forKey:@"AllowedURLPatterns"];
    [retDict setObject:[disAllowedURLPatternsTextField stringValue] forKey:@"DisAllowedURLPatterns"];

    return [NSDictionary dictionaryWithDictionary:retDict];
}

- (NSArray *)optionsForRun
{
    NSMutableArray *retValue = [NSMutableArray array];

    if ([[allowedFilePrefixesTextField stringValue] length]) {
        [retValue addObject:@"-aprefix"];
        [retValue addObject:[[[allowedFilePrefixesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedFilePrefixesTextField stringValue] length]) {
        [retValue addObject:@"-dprefix"];
        [retValue addObject:[[[disAllowedFilePrefixesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedFileSuffixesTextField stringValue] length]) {
        [retValue addObject:@"-asfx"];
        [retValue addObject:[[[allowedFileSuffixesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedFileSuffixesTextField stringValue] length]) {
        [retValue addObject:@"-dsfx"];
        [retValue addObject:[[[disAllowedFileSuffixesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedDomainsTextField stringValue] length]) {
        [retValue addObject:@"-adomain"];
        [retValue addObject:[[[allowedDomainsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedDomainsTextField stringValue] length]) {
        [retValue addObject:@"-ddomain"];
        [retValue addObject:[[[disAllowedDomainsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedMIMETypesTextField stringValue] length]) {
        [retValue addObject:@"-amimet"];
        [retValue addObject:[[[allowedMIMETypesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedMIMETypesTextField stringValue] length]) {
        [retValue addObject:@"-dmimet"];
        [retValue addObject:[[[disAllowedMIMETypesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedSitesTextField stringValue] length]) {
        [retValue addObject:@"-asite"];
        [retValue addObject:[[[allowedSitesTextField stringValue] componentsSeparatedByString:@","] componentsJoinedByString:@","]];
    }
    if ([[disAllowedSitesTextField stringValue] length]) {
        [retValue addObject:@"-dsite"];
        [retValue addObject:[[[disAllowedSitesTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedFilePatternsTextField stringValue] length]) {
        [retValue addObject:@"-pattern"];
    	[retValue addObject:[[[allowedFilePatternsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedFilePatternsTextField stringValue] length]) {
        [retValue addObject:@"-skip_pattern"];
    	[retValue addObject:[[[disAllowedFilePatternsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[allowedURLPatternsTextField stringValue] length]) {
        [retValue addObject:@"-url_pattern"];
    	[retValue addObject:[[[allowedURLPatternsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    if ([[disAllowedURLPatternsTextField stringValue] length]) {
        [retValue addObject:@"-skip_url_pattern"];
    	[retValue addObject:[[[disAllowedURLPatternsTextField stringValue] componentsSeparatedByString:@" "] componentsJoinedByString:@","]];
    }
    
    return [NSArray arrayWithArray:retValue];
}

@end
